(defun C:QUIZ ()
   (setq QNAME (getenv "QUIZNAME"))
   (if (null QNAME)
     (setq QNAME (getfiled "Select quiz name please" "" "qz" 8)))
   (if (or (null QNAME) (null (findfile QNAME)))
       (progn
         (alert "Unable to find quiz file master, abort")
         (exit)
       )
   )
   (setq Q_FH (open (findfile QNAME) "r"))
   ;
   ;  User name
   (setq DCL_ID (load_dialog "CDNC1-93.DCL")
         USER (who_are_you))
   ;
   ;  Do the Quiz
   (setq T_START (getvar "DATE")
         C_START (getvar "CDATE")
         SCR (list 0 0))
   (while Q_FH
      (setq LN (read-line Q_FH))
      (if (and LN (= (substr LN 1 1) "#"))
        (progn
           (setq QS nil
                 AS nil)
           (repeat 4
              (setq QS (cons (read-line Q_FH) QS)))
           (repeat 4
              (setq AS (cons (read-line Q_FH) AS)))
           (setq AA (read-line Q_FH)
                 AS (reverse AS)
                 QS (reverse QS))
           (setq SCR (do_question QS AS AA SCR))
        )
        (setq Q_FH (close Q_FH))
      )
   )
   (setq T_STOP (getvar "DATE")
         DCL_ID (unload_dialog DCL_ID)
         A_FH (open "QUIZES.ANS" "a"))
   (write-line
      "--------------------------------------------"
      A_FH)
   (write-line
     (strcat
        USER " | "
        QNAME " | "
        (itoa (car SCR)) " / "
        (itoa (cadr SCR)) " | "
        (rtos (* 100.0
                 (/ (float (car SCR)) (cadr SCR)))
              2 2)
        "% | "
        (rtos (* 1440 (- T_STOP T_START)) 2 2) " mins."
     )
     A_FH)
   (setq A_FH (close A_FH))
   (princ)
)
Listing 3
(defun WHO_ARE_YOU ( / ME)
  (if (new_dialog "INTRO" DCL_ID)
    (progn
       (while (null ME)
          (action_tile "NAME" "(setq ME $value)")
          (start_dialog)
          (if (null ME)
            (new_dialog "INTRO" DCL_ID))
       )
    )
  )
  ME
)
;
;------------------------------------------------
 Listing 4
;
(defun DO_QUESTION (QS AS AA SCR / AIN COR)
  (setq COR 0)
  (if (new_dialog "QUEST" DCL_ID)
    (progn
      (setq CNT 1)
      (repeat 4
        (set_tile
           (strcat "Q" (itoa CNT))
           (nth (1- CNT) QS))
        (set_tile
           (strcat "A" (itoa CNT))
           (nth (1- CNT) AS))
        (action_tile
           (strcat "B" (itoa CNT))
           "(done_dialog
               (+ 10 (atoi (substr $key 2 1))))")
        (setq CNT (1+ CNT))
      )
      (set_tile "STAT"
         (strcat "Current score: "
                 (itoa (car SCR)) " out of "
                 (itoa (cadr SCR)) " correct."))
      (setq AIN (start_dialog))
      (if
        (or (= AIN 1) (/= AIN (+ 10 (atoi AA))))
          (progn
            (alert
              (strcat "The correct answer was "
                      AA ", "
                      (nth (1- (atoi AA)) AS)))
            (setq COR 0)
          )
          (setq COR 1)
      )
    )
  )
  (list (+ (car SCR) COR) (1+ (cadr SCR)))
)
