;;;Listing 4
(defun C:SETDS ()
	(setvar "CMDECHO" 0)
	(setq e1(car(entsel "\nSelect dimension to use for base style: ")))
	(setq as(entget e1))
	(setq base (cdr(assoc 3 as)))
	(command "Dim")
	(if(not (tblsearch "DIMSTYLE" (strcat base "_B")))
		(progn
			(setvar "DIMSE1" 0)(setvar "DIMSE2" 0)
			(command "Sav" (strcat base "_B"))))
	(if(not (tblsearch "DIMSTYLE" (strcat base "_N")))
		(progn
			(setvar "DIMSE1" 1)(setvar "DIMSE2" 1)
			(command "Sav" (strcat base "_N"))))
	(if(not (tblsearch "DIMSTYLE" (strcat base "_1")))
		(progn
			(setvar "DIMSE1" 0)(setvar "DIMSE2" 1)
			(command "Sav" (strcat base "_1"))))
	(if(not (tblsearch "DIMSTYLE" (strcat base "_2")))
		(progn
			(setvar "DIMSE1" 1)(setvar "DIMSE2" 0)
			(command "Sav" (strcat base "_2"))))
	(initget 1 "B N 1 2")
	(setq current
		(getkword "\nCurrent extension line display status
			<B>oth,<N>one,<1>st,<2>nd: "))
	(command "Restore" (strcat base "_" current)
		"update" e1 "" "exit") 
	(prompt "\Done")
	(prin1)
) 

(defun C:TS ()(ts))

(defun TS ()
	(setvar "CMDECHO" 0)
  (setq e1 (car (entsel "\nSelect dimension to change: ")))
  (setq as (entget e1))
  (setq base (cdr (assoc 3 as)))
	(if(member 
      (setq current (substr base (- (strlen base) 1) 2))
      '("_B" "_N" "_1" "_2"))
		(progn
			(setq current (substr current 2 1))
			(setq base (substr base 1 (- (strlen base) 2))) 
			(while (/= current "X")
				(cond
          ((= current "B")
            (setq ctext "Both extension lines are displayed." ntext "<None>")
          )
          ((= current "N")
            (setq ctext "No extension lines are displayed." ntext "<First>")
          )
          ((= current "1")
            (setq ctext "First extension line is displayed." ntext "<Second>")
          )
          ((= current "2")
            (setq ctext "Second extension line is displayed." ntext "<Both>")
          )
        )
				(prompt (strcat "\nCurrently: " ctext))
				(initget "X B N 1 2")
				(setq toggle(getkword
            (strcat "\nShow extension lines: B, N, 1, 2, or X to exit " ntext)))
				(cond 
					((= toggle nil)
						(cond
							((= current "B")(setq current "N")) 
							((= current "N")(setq current "1"))
							((= current "1")(setq current "2"))
							((= current "2")(setq current "B"))))
					(T (setq current toggle)))
				(if(/= current "X")
					(command "Dim" "Restore" 
						(strcat base "_" current)
            "update" e1 "" "exit")
        )
      )
    )
    (prompt "\nDimension style not setup or style not used!")
	)
	(prin1)
)
