(defun c:sort ()
	(sortfile "test.txt" 1 8))
(defun SORTFILE (filenam start1 end1)
	(setvar "CMDECHO" 0)
	(setq fn1 "sort1.bak"
		fn2 "sort2.bak"
		fp2 (open fn2 "w")
		fp (open filenam "r")
		line1 T lcnt 0
	) ;end setq
	; Count the number of lines in the file
	; and copy file to fn1
	(while line1
		(setq line1 (read-line fp))
		(if line1
			(progn
				(setq lcnt (1+ lcnt))
				(write-line line1 fp2)
			) ;end progn
		) ;end if
	) ;end while
	(close fp)
	(close fp2)
	; Sort data by description
	(setq rcnt 0)
	(repeat lcnt
	(setq fn3 fn2  ; Flip flop file names
			fn2 fn1
			fn1 fn3
			fp1 (open fn1 "r")
			fp2 (open fn2 "w")
			line1 (read-line fp1)
		) ;end setq
		(repeat (1- lcnt) 
			(setq line2 (read-line fp1))
			(if
				(<= (substr line1 start1 end1)  ; Compares data in line1 and line2
					(substr line2 start1 end1)) ; and reverses the order if line1
				(progn                                     ;is > line 2 
					(write-line line1 fp2)
					(setq line1 line2)
				) ;end progn
				(write-line line2 fp2)
			) ;end if
		) ;end repeat
	(write-line line1 fp2)  
			;Write last line
		(close fp1)
		(close fp2)
	) ;end repeat
	; Copy sorted file to filenam
	(setq fp(open filenam "w"))
	(setq fp2(open fn2 "r"))
	(repeat lcnt
		(setq line1 (read-line fp2))
		(write-line line1 fp)
	) ;end repeat
	(close fp)
	(close fp2)
	(prin1)
) ;end sortfile